# A standardized TTR program. Reads all the text files in a directory and calculates the TTR. The results are saved in TTResults.txt
#!/usr/local/bin/perl
use locale;

print "Enter TTR base:";
$base = <STDIN>;
chomp $base;
print "Enter the path where the text files are:\nRemember to put double slashes (\\\\) or backslash (/)\n";
$dir = <STDIN>;
chomp $dir;

opendir(BIN, $dir) or die "Can't open $dir: $!";
open (OUTFILE, ">Tesults.txt");
print OUTFILE ("Filename\tTokens\tTypes\tSTTR\tRevSTTR\n");

while(defined ($file = readdir BIN)) {
			  next if $file =~ /^\.\.?$/;
			  next if $file =~ /pl$/;
			  next if $file =~ /[T|R]esults\.txt/;
  			  open (FILE, "$file");

@array = ();
@sub = ();
@sortarray = ();
$d = 0;
%hash = ();
%tothash = ();
@revarray = ();
@revsub = ();
%revhash = ();

while( <FILE> ) {
       chomp ($_);
       s/$//g;		# converts to greek final -s
       $d = lc $_;		# converts to lower case
       $tothash{$d} = 1;    	# %tothash is used for aquiring all the types of the text. The hash is creating adding 1 in each token. 1 is not used in anything.
       push @array, $_;		# @array is used for all the tokens of the text.
}
close(FILE);

$tokens = 0;			#initialize the variables
$start = 0;
$end = 0;
$i = 0;
$subtokens = 0;
$c = 0;
$types = 0;
$TTR = 0;
$TotTTR = 0;
$STTR = 0;
$TotTypes = 0;
$l = 0;
$revsubtokens = 0;
$revtypes = 0;
$revTTR = 0;
$revTotTTR = 0;


$tokens = @array;               # returns the number of the tokens
@revarray = reverse (@array);	# prepares a reversed array in order to compute TTR backwards
$div = int($tokens/$base);      # finds the integer number of x word pieces the text should be cut
if ($div == 0) {		#takes care the case where the TTR base is greater than the size of the text and prevents from dividing with zero
       $div+=1;
}
if ($tokens >= $base) {
       $start = 0;                         		# initialize the start index for finding x consecutive words in the array
       $end = 0;                           		# initialize the start index for finding x consecutive words in the array
   	for ($i=1; $i<=$div; ++$i) {        		# the loop iterates n times where n the number of times a text can be divided in x word pieces
	      if ($i>1) {				#This if adds 1 to the start after the first loop in order to avoid the start of the next loops to capture the last element of the previous loop
		     $start = $end +1;
		     $end = $start + ($base -1);
	      }
	      else {
		     $start = $end;                  	# starts with 0 $start and 0 $end
		     $end = $start + ($base -1); 	# adds x-1 to the $start so that in the next cucle $start will begin at the position where the $end was in the previous cucle
	      }
	      @sub = @array[$start..$end];    		# takes the x word subtext and put is in a subarray (@sub)
	      $subtokens = @sub;
	      %hash = ();
	      foreach (@sub) {
		     s/$//g;				# converts to greek final -s
		     $c = lc $_;			# converts to lower case
		     $hash{$c} = 1;    			# creates a hash adding 1 in each token. 1 is not used in anything.
	      }
	      $types = keys %hash;       		#returns the number of the keys
	      $TTR = $types/$subtokens;
	      print ("$TTR\n");
	      $TotTTR += $TTR;

	      @revsub = @revarray[$start..$end];    		# takes the reverse x word subtext and put is in a subarray (@sub)
	      $revsubtokens = @revsub;
	      %revhash = ();
	      foreach (@revsub) {
		     s/$//g;				# converts to greek final -s
		     $l = lc $_;			# converts to lower case
		     $revhash{$l} = 1;    		# creates a reverse hash adding 1 in each token. 1 is not used in anything.
	      }
	      $revtypes = keys %revhash;       		#returns the number of the keys in the reverse subarray
	      $revTTR = $revtypes/$revsubtokens;
	      print ("rev $revTTR\n");
	      $revTotTTR += $revTTR;

       }
}
else {
       $tokens = @array;
       foreach  (@array) {
	      $c = lc $_;
	      $hash{$c} = 1;    			# creates a hash adding 1 in each token. 1 is not used in anything.
       }
       $types = keys %hash;       			#returns the number of the keys
       $TTR = $types/$tokens;
}
$STTR = $TotTTR/$div;
$TotTypes = keys %tothash;

$revSTTR = $revTotTTR/$div;
$revTotTypes = keys %tothash;

print ("Total Tokens: $tokens\n");
print ("Types: $types\n");
print ("Total Types: $TotTypes\n");
print ("Standardized Type/Token Ratio: $STTR\n");
print ("Revers St. Type/Token Ratio: $revSTTR\n");


print OUTFILE ("$file\t$tokens\t$TotTypes\t$STTR\t$revSTTR\n");

}


close OUTFILE;
closedir(BIN);
